package othello.models;

/**
 * Le modle du jeu, la classe que vous avez  complter.
 * @author Jean-Franois Berdjugin
 * La classe GameModel permet de caractriser un jeu.
 * Un jeu est compos d'un plateau et du joueur courant.
 */
public class GameModel {

	/**
	 * Le plateau de jeu est dfini par un tableau  deux dimensions de 8 cases par 8 cases.
	 * Si une case contient la valeur 1 alors elle contient un pion du premier joueur.
	 * Si une case contient la valeur -1 alors elle contient un pion du deuxime joueur.
	 * Si une case contient la valeur 0 alors elle est vide. 
	 *board[x][y] est la case d'abscisse x et d'ordonne y
	 *board[0][0] est la case en haut  gauche.
	 */
	
	private int[][] board;
	/**
	 * L'utilisateur courant.
	 * Les valeurs possibles sont 1 pour un pion du premier joueur ou -1 pour un pion du deuxime joueur.
	 */
	private int currentUser;

	/**
	 * Le constructeur qui cr un plateau avec les casses du centre initialises 
	 * et comme joueur courant, le premier joueur. 
	 */
	public GameModel()
	{
		this.initBoard();
	}
	
	/**
	 * Permet de savoir si un utilisateur peut jouer.
	 * @return true si le joueur courant peut jouer et false sinon.
	 */
	public boolean currentUserCanPlay()
	{
		boolean res = false;
		
		return res;
	}

	/**
	 * Une mthode qui pour une position, une direction en abscisse et en ordonne permet 
	 * de calculer le nombre de pion que l'on peur retourner. 
	 * @param x l'abscisse du coup que l'on souhaite jouer
	 * @param y l'ordonne du coup que l'on souhaite jouer
	 * @param dx -1,0,1 suivant la variation des x souhaite
	 * @param dy -1,0,1 suivant la variation des y souhaite
	 * @return le nombre de pion que l'on peut retourner
	 */
	private int currentUserPlayableCount(int x, int y,int dx, int dy)
	{
		

		return 0;
	}

	/**
	 * Permet de connatre le nombre de pions du premier joueur sur le plateau 
	 * @return le nombre de pions du premier joueur sur le plateau
	 */
	public int getFirstPlayerCount()
	{
		
		return 0;
	}

	/**
	 * Renvoie le plateau de jeu 
	 * @return le plateau de jeu
	 */
	public int[][] getBoard() {
		return board;
	}

	/**
	 * Renvoie le joueur courant
	 * @return le joueur courant : 1 premier joueur, -1 deuxime joueur
	 */
	public int getCurrentUser() {
		return currentUser;
	}

	/**
	 * Permet de connatre le nombre de pions du second joueur sur le plateau 
	 * @return le nombre de pions du second joueur sur le plateau
	 */
	public int getSecondPlayerCount()
	{
		
		return 0;
	}

	/**
	 * Permet d'initialiser le plateau de jeu et de dfinir le joueur courant 
	 * comme tant le premier joueur(1).
	 */
	public void initBoard()
	{
		this.board = new int[8][8];
		//a vous de continuer
	}

	/**
	 * Permet de savoir si le plateau est plein.
	 * 
	 * @return true si le plateau est plein et false sinon
	 */
	public boolean isFull()
	{
		
		return false;
	}

	/**
	 * Permet de savoir si la case de coordonnes (x,y) est jouable
	 * @param x l'abscisse
	 * @param y l'ordonne
	 * @return true si la case et jouable et false sinon
	 */
	public boolean isPlayable(int x, int y)
	{
		
		return false;
	}

	/**
	 * Joue le coup si il est jouable
	 * @param x l'abscisse choisie
	 * @param y l'ordonne choisie
	 */
	public void playXY(int x, int y)
	{
		
	}

	/**
	 * Tri le plateau de jeu avec les pions du premier joueur en haut et les pions du deuxime joueur en bas.
	 */
	public void sort()
	{
		
		
	}
	
	/**
	 *Permet de changer l'utilisateur courant
	 *Si l'utilisateur courant est le premier joueur (1) alors il devient le second (-1) et inversement. 
	 */
	public void swichUser() {
		

	}
}
