package utils;

import java.awt.Image;
import java.io.IOException;
import java.net.URL;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

/**
 * Classe utilitaire de manipulation d'images
 * @author Jean-Franois Berdjugin
 *
 */
public class ImageUtils {
	/**
	 * Permet de crer une icone
	 * @param url la source de l'image
	 * @return une image de 20 par 20  pixels
	 */
	public static ImageIcon resizeImageIcon(URL url)
	{
		Image image = null;
		ImageIcon icon;
		try {
			image = ImageIO.read(url);
			image = image.getScaledInstance(20, 20, Image.SCALE_SMOOTH);

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		icon=new ImageIcon();
		icon.setImage(image);
		return icon;
	}
}
